#
# tkgeomap: najprostszy przyklad uzycia pakietu (wyczyszczony!)
#

source geomap.tcl
  # urposzczone instalowanie pakietu ...
package re tkgeomap
  #% 2.11.4
    
canvas .c
pack .c -fill both -expand 1

geomap::lnarr fmxdr w1 ~/tcl/geomap/xeartk-2.2/data/land.xdr
geomap::lnarr fmxdr w2 ~/tcl/geomap/xeartk-2.2/data/rivers.xdr
geomap::lnarr fmxdr w3 ~/tcl/geomap/xeartk-2.2/data/water.xdr
    
set m1 [.c create geomap_lnarr 260 280 -lnarr w1 -tags www]
set m2 [.c create geomap_lnarr 260 280 -lnarr w2 -tags www]
set m3 [.c create geomap_lnarr 260 280 -lnarr w3 -tags www]

set proj [geomap::projection Mercator 0]
.c itemconf www -projection $proj -scale .08e-7

# obsluga zdarzen pozwalajaca "wlec" mape ...
set bb 0
bind .c <Button-1> {set bb 1; set xx %x; set yy %y}
bind .c <ButtonRelease-1> {set bb 0}
bind .c <Motion> {
  if {!$bb} continue
  .c move www [expr %x-$xx] [expr %y-$yy]
  set xx %x; set yy %y
}

# guziki do zmiany skali ...
set scale .08e-7
frame .guziki; pack .guziki
button .guziki.b1 -text "-" -command {zmienSkale .8}
pack .guziki.b1 -side left
button .guziki.b2 -text "+" -command {zmienSkale 1.2}
pack .guziki.b2 -side left
proc zmienSkale wsp {
  ustawFokus
  set ::scale [expr $::scale*$wsp]
  .c itemconf www -scale $::scale
}

# konfiguracja elem. graf. i canvasu
.c config -bg grey
.c itemconf $m1 -fill green
.c itemconf $m2 -outline red
.c itemconf $m2 -width 2
.c itemconf $m3 -fill blue

# proc ustawiajace wsp geo i canvasa ...
proc ustawFokusNa {lat lon} {
  set x [expr {[winfo width .c]/2}]
  set y [expr {[winfo height .c]/2}]
  foreach e [.c find all] {
    .c coords $e "$x $y"
    .c itemconf $e -refpoint "$lat $lon"
  }
}
proc ustawFokus {} {
  set x [expr {[winfo width .c]/2}]
  set y [expr {[winfo height .c]/2}]
  eval ustawFokusNa [geomap::xytolatlon .c $::m1 $x $y]
    # musialem wprowadzci poprawki do tkgeomap_procs.tcl !
}



if 0 { 
## umieszczanie "places" na mapie ...
# - musi byc umieszczony w tym samym pkt canvasa oraz 
#   z tym samym -refpoint co $::m1 !!!

geomap::place new q1 {0 0} 
eval ".c create geomap_place [.c coords $::m1] -place q1 -tags www \
  -dotsize 15 -dotcolor pink -text ???????? \
  -projection $proj -scale $scale \
  -refpoint {[.c itemcget $::m1 -refpoint]}
"


}  

